﻿Type=Activity
Version=1.90
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Dim Blib As BasicLibIDE
	Dim StepState As Boolean
	Dim BreakLine As Int
	Dim Program As String
	Dim FirstRunFlag As Boolean
	Dim SavedData(0) As String
	
	Dim ScriptVersion As Double
	' 1.3 Removed limit of 6 menu items
	' 1.4	added InputFile and InputNumber dialogs
	'			added OpenMenu, CloseMenu, FillArray, SortArray, SearchArray 
	' 1.5	no changes but re-versioned to match the latest BasicIDE library
	' 1.6	no changes but re-versioned to match the latest BasicIDE library
	' 1.7	no changes but re-versioned to match the latest BasicIDE library
	' 1.8	added custom area for new functions to be added by BasicLibIDE.AddSysCalls
	'			added call of AddNewSysCalls to Activity_Create
	' 1.9	added test args() for bug fix in BasicIDE v1.9
	ScriptVersion = 1.9 ' requires BasicLibIDE version 1.9
	Dim ChainProgram As String:		ChainProgram = ""
	Dim ChainError As String:		ChainError = ""
	Dim Args(0) As String
	Dim RunProgram As String:		RunProgram = ""
	Dim RunError As String:			RunError = ""
	Dim Restarting As Boolean : 		Restarting = False
	Dim ForceActivityResume As Boolean : ForceActivityResume = False
	Dim tmrChain As Timer	'used for chaining and running other scripts
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Dim viewmap As Map ' holds all views
	Dim defmap As Map ' holds the defaults
	Type defstdtype(radius As Int, color As Int, tcolor As Int, tsize As Int, grav As Int, tface As Boolean)
	Type defexttype(radius As Int, color As Int, tcolor As Int, tsize As Int, grav As Int, tface As Boolean, itype As Int, sline As Boolean)

	Dim bmp As Bitmap ' one bitmap	
	Dim draw As Canvas ' one canvas	
	Dim font As Typeface ' one typeface
	Dim istream As InputStream ' one in stream
	Dim ostream As OutputStream ' one out stream
	Dim timer1 As Timer '  one timer
	Dim arraysX As ArraysExtra
	
	Dim aw As Int ' screen width
	Dim ah As Int ' screen height
	Dim input ' last dialog input
	
	Dim nextmenuitem As Int
	Dim menuitems(0) As String
	
	Dim starting As Boolean ' used to detect and ignore first Ended event after the inital block has completed
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.Title = "B4Script"
	aw = Activity.Width
	ah = Activity.Height
	
	nextmenuitem = 0
	Dim menuitems(6) As String
	Dim ok As Boolean
	
	font = Typeface.CreateNew(Typeface.DEFAULT, Typeface.STYLE_NORMAL)
	timer1.Initialize("Timer", 1000)
	Blib.Initialize("Blib")
	AddNewSysCalls
	Blib.StackDepth = Main.StackSize
	Blib.Step = StepState
	Blib.BreakAtLine = BreakLine
	viewmap.Initialize
	defmap.Initialize
	ok = Blib.LoadCodeAsString(Include(Program))
	If ok Then
		Blib.Run(Args)
	Else
		Blib_Ended(Blib.ErrorString)
	End If	
End Sub

Sub Activity_Resume
	' Can check GetFirstTime to see if it has run before and retrieve saved persistent data with GetSavedData
	If Blib.CanCall("Activity_Resume") Then ' check if the Sub exists
		Blib.Call("Activity_Resume", Null) ' can save persistent data with SetSavedData
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	FirstRunFlag = False
	If Blib.CanCall("Activity_Pause") Then ' check if the Sub exists
		Dim params(1) As String
		params(0) = UserClosed
		Blib.Call("Activity_Pause", params) ' can save persistent data with SetSavedData
	End If
	timer1.Enabled = False
	If UserClosed Then Main.BackFromScript = True
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event
	If Blib.CanCall("Activity_KeyPress") Then
		Dim rtn As String
		Dim params(1) As String
		params(0) = KeyCode
		rtn = Blib.Call("Activity_Keypress", params)
		If rtn.ToLowerCase = "true" Then
			Return True
		Else
			Return False
		End If
	End If
	Return False
End Sub
#Region BasicLib Events

Sub Blib_Loaded(error As String) 'Error is an empty string if the script loaded without error	
	If error <> "" Then
		msg = "Error at line " & Blib.LineNumber & CRLF
		msg = msg & "Code - " & Blib.ProgramLine(Blib.LineNumber) 
		msg = msg & "Error - " & Blib.ErrorString 
		Msgbox(msg,"Error loading script")
		Activity.Finish
	End If
End Sub

Sub Blib_Starting 'The script has initialised its variables and is about to start executing
	starting = True
End Sub

Sub Blib_Break(linenumber As Int) 'The script has stopped at linenumber
	msg = "Break at line " & Blib.linenumber & " : "  & Blib.ProgramLine(Blib.linenumber) & CRLF
	msg = msg & "Step to step one line" & CRLF
	msg = msg & "Run to keep break" & CRLF
	msg = msg & "Cancel to clear break"	
	ret = Msgbox2(msg,"Break", "Step", "Run", "Cancel" & CRLF & "Break", Null)
	If ret = DialogResponse.NEGATIVE Then
		Blib.BreakAtLine = 0
	Else If ret = DialogResponse.POSITIVE Then
		Blib.Step = True
	Else If ret = DialogResponse.CANCEL Then
		Blib.Step = False			
	End If	
End Sub

Sub Blib_Stepped(linenumber As Int) 'The script has stepped to linenumber

	msg = "Stepped to line " & Blib.linenumber & " : "  & Blib.ProgramLine(Blib.linenumber) & CRLF
	msg = msg & "Continue stepping?"
	ret = Msgbox2(msg,"Stepped", "Yes", "No", "", Null)
	If ret <> DialogResponse.POSITIVE Then
		Blib.Step = False
	End If
	
End Sub

Sub Blib_Ended(error As String) 'Error is an empty string if the script terminated without error
	If ChainProgram.Length > 0 OR RunProgram.Length > 0 OR Restarting Then
	Else If starting AND error = "" Then ' don't stop after initial code block exits except on error
		starting = False
		'this is needed because the new chain, run and restart commands
		'	don't actually exit this activity back to the main activity
		'	and come back here to the script activity, the new script's
		'	activity_resume event is never triggered. this will force it
		If ForceActivityResume Then
			ForceActivityResume = False
			If Blib.CanCall("Activity_Resume") Then
				Dim params(0) As String
				Blib.Call("Activity_Resume", params)
			End If
		End If
		Return
	End If
	If Blib.ErrorString <> "" Then
		msg = "Error at line " & Blib.LineNumber & CRLF
		msg = msg & "Code - " & Blib.ProgramLine(Blib.LineNumber) 
		msg = msg & "Error - " & Blib.ErrorString 
		Msgbox(msg,"Ended with error")
'	Else
'		Msgbox("Ended OK", "Ended")
	End If
	RemoveAllViews
	Activity.Finish
'	If ChainProgram.Length + RunProgram.Length = 0 AND Not(Restarting) Then
'		Activity.Finish
'	Else
'		tmrChain.Initialize("tmrChain", 100)
'		tmrChain.Enabled = True
'	End If
End Sub

Sub Blib_Message(message As String, subject As String)
	Msgbox(message, subject)
End Sub

#End Region

#Region Script support Subs

Sub AddView(o As Object, name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim v As View
	v = viewmap.Get(parent)
	If v.IsInitialized  Then
		If v Is Panel Then
			Dim p As Panel
			p = v
			p.AddView(o, left, top, width, height)
		End If
	Else
		Activity.AddView(o, left, top, width, height)
	End If
	viewmap.Put(name, o)
End Sub

Sub Include(src As String) As String
	Dim ix, ix2, ixs As Int
	Dim str, strs As String
	Dim istream As InputStream
	Dim reader As TextReader
	Dim sfor As String
	Dim spath As String
	If Main.IDEMode Then
		If Main.ProjectPath.Length > 0 Then
			spath = Main.ProjectPath
		Else
			spath = Main.ScriptPath
		End If
	Else
		spath = File.DirAssets
	End If
	sfor = Chr(10) & "#include " & QUOTE
	ix = src.ToLowerCase.IndexOf(sfor)
	Do While ix >= 0
		ix2 = src.IndexOf2(QUOTE & Chr(10), ix)
		If ix2 = -1 Then
			ix = -1
			Exit
		End If
		str = src.SubString2(ix + sfor.Length, ix2)
		If Not(str.EndsWith(".b4s")) Then str = str & ".b4s"
		If Not(File.Exists(spath, str)) Then
			ix = src.ToLowerCase.IndexOf2(sfor, ix2)
		Else
			istream = File.OpenInput(spath, str)
			reader.Initialize(istream)
			str = reader.ReadAll
			str = str.Replace(Chr(Main.BOM), "")
			str = str.Replace(Chr(13), "")
			ixs = str.ToLowerCase.IndexOf(Chr(10) & "sub ")
			If ixs = -1 Then
				strs = ""
			Else
				strs = str.SubString(ixs)
				str = str.SubString2(0, ixs + 1)
			End If
			src = src.SubString2(0, ix + 1) & _
				str & src.SubString(ix2 + 1) & strs
			ix = src.ToLowerCase.IndexOf2(sfor, ix)
		End If
	Loop
	Return src
End Sub

#End Region

' Subs below are called by the running script
' Do Edit -> Outlining -> Collapse All then expand the regions below to conveniently see what functions are available
''<a name="top"></a>
''BASICIDE V2.8 HELP CONTENTS
''
''<a href="#device">Device Functions</a><p>
''<a href="#activity">Activity Functions</a><p>
''<a href="#events">Views and Events</a><p>
''<a href="#view">View Functions</a><p>
''<a href="#textview">TextView Functions</a><p>
''<a href="#edittext">EditText Functions</a><p>
''<a href="#check">Check, Radio and Toggle Functions</a><p>
''<a href="#timer">Timer Functions</a><p>
''<a href="#seekbar">SeekBar Functions</a><p>
''<a href="#scrollview">ScrollView Functions</a><p>
''<a href="#spinner">Spinner Functions</a><p>
''<a href="#listview">ListView Functions</a><p>
''<a href="#listandspin">ListView and Spinner Functions</a><p>
''<a href="#tabhost">TabHost Functions</a><p>
''<a href="#graphics">Graphics Functions</a><p>
''<a href="#arrays">Array Functions</a><p>
''<a href="#user">User Interaction Functions</a><p>
''<a href="#file">File Functions</a><p>
''<a href="#custom">Custom functions</a><p>
''<a href="#other">Additional View Events</a>

#Region Device functions
''<a name="device"></a>
''DEVICE FUNCTIONS
''
''Get the available width of the window.
'' Depending upon the device orientation this is not necessarily the same as the physical display width.
Sub WindowWidth
	Return aw
End Sub

''Get the available height of the window.
'' Depending upon the device orientation this is not necessarily the same as the physical display height.
Sub WindowHeight
	Return ah
End Sub

''Get the scaling value (density) for this device.
Sub ScreenScale
	Return GetDeviceLayoutValues.Scale
End Sub

''Get the layout values for this device in a comma separated string "width,height,density",
Sub GetLayoutValues
	Dim l As LayoutValues
	l = GetDeviceLayoutValues
	Return l.Width & "," & l.Height & "," & l.Scale
End Sub


#End Region

#Region Activity functions
''<a href="#top">Contents</a>
''<a name="activity"></a>
''ACTIVITY FUNCTIONS
''
''Returns true if this is the first time the initial code block program has been run.
''This is the equivalent of FirstTime in Activity_Create.
Sub GetFirstTime
	Return FirstRunFlag
End Sub

''Get a previously saved an array of persistent data that will survive activity destruction.
Sub GetSavedData(dataarrayname As String)
	Blib.SetArray(dataarrayname, SavedData)	
End Sub

''Save an array of data that will survive activity destruction.
Sub SetSavedData(dataarrayname As String)
	SavedData = Blib.GetArray(dataarrayname)	
End Sub

''Close the Activity and return to the editor
''Call this at the end of the initial code block for a program that does not support events otherwise the
''program will be left waiting for an event that won't come and the back button will be needed to close it.
''A program that does support events can end by calling AppClose or this.
Sub ActivityFinish
	Activity.Finish
End Sub

''Set the Background property of the Activity to the GradientDrawable.
''Returns false if less than two colors are in the array otherwise returns true.
''Orientation can be one of the following - 
''"TOP_BOTTOM", "TR_BL" (Top-Right To Bottom-Left, "RIGHT_LEFT", "BR_TL" (Bottom-Right To Top-Left)
''"BOTTOM_TOP", "BL_TR" (Bottom-Left To Top-Right), "LEFT_RIGHT", "TL_BR" (Top-Left To Bottom-Right)
Sub SetActivityBackground(orientation As String, radius As String, colorsarrayname As String)
	Dim cols(0) As String
	Dim G As GradientDrawable
	cols = Blib.GetArray(colorsarrayname)
	If cols.Length >= 2 Then
		Dim colints(cols.Length) As Int
		For I = 0 To cols.Length - 1
			colints(I) = cols(I)
		Next
		G.Initialize(orientation, colints)
		G.CornerRadius = radius
		Activity.Background = G
		Return True
	End If
	Return False
End Sub

''Logs the provided message to the Logcat output.
Sub LogCat(message As String)
	Log(message)
End Sub

'' Closes the Activity menu. This is added for symmetry with OpenMenu but seems of little practical use.
Sub CloseMenu
	Activity.CloseMenu
End Sub

'' Opens the Activity menu
Sub OpenMenu
	Activity.OpenMenu
End Sub

#End Region

#Region Views and Events
''<a href="#top">Contents</a>
''<a name="events"></a>
''VIEWS AND EVENTS
''
''On Activity_Create the inital block of code up to the first Sub statement is run. GetFirstTime returns true the first time.
''On Activity_Pause "Sub activity_pause(userclosed)" is called if implemented.
''On Activity_Resume "Sub activity_resume" is called if implemented.
''All MenuItem Click events are vectored to a single BasicLib sub "Sub menu_click(menutext)".
''All Button Click events are vectored to a single BasicLib sub "Sub button_click(sender)".
''All Checkbox CheckedChange events are vectored to a single BasicLib sub "Sub check_change(sender, checked)".
''All EditText TextChanged events are vectored to a single BasicLib sub "Sub edit_change(sender, oldtext, newtext)".
''All EditText EnterPressed events are vectored to a single BasicLib sub "Sub edit_enterpressed(sender)".
''All ListView ItemClick events are vectored to a single BasicLib sub "Sub listview_itemclick(sender, position, value)".
''All RadioButton CheckedChange events are vectored to a single BasicLib sub "Sub radio_change(sender, checked)".
''All SeekBar ValueChanged events are vectored to a single BasicLib sub "Sub seekbar_valuechanged(sender, value, userchanged)".
''All Spinner ItemClick events are vectored to a single BasicLib sub "Sub spinner_itemclick(sender, position, value)".
''All TabHost TabChanged events are vectored to a single BasicLib sub "Sub tabhost_tabchanged(sender)".
''All ToggleButton CheckedChange events are vectored to a single BasicLib sub "Sub toggle_change(sender, checked)".
''Sender will be set to the name of view that caused the event.
''If a view raising events is added then the appropriate event Sub or Subs must be present in the program.

#Region Sub templates
''
''Here are all the event Sub templates to copy and paste if desired.
''
''Sub activity_pause(userclosed) 
''End Sub
''
''Sub activity_resume
''End Sub 
''
''Sub button_click(who)
''End Sub 
''
''Sub check_change(who, checked)
''End Sub 
''
''Sub edit_change(who, old, new)
''End Sub
''
''Sub edit_enterpressed(who)
''End Sub
''
''Sub listview_itemclick(who, pos, value)
''End Sub
''
''Sub menu_click(menutext)
''End Sub
''
''Sub radio_change(who, checked)
''End Sub 
''
''Sub seekbar_valuechanged(who, pos, value)
''End Sub
''
''Sub spinner_itemclick(who, pos, value)
''End Sub
''
''Sub tabhost_tabchanged(who)
''End Sub 
''
''Sub toggle_change(who, checked)
''End Sub 
''
#End Region

#Region Menu events

Sub Menu_Click
	If Blib.CanCall("Menu_Click") Then
		Dim params(1) As String
		params(0) = Sender
		Blib.Call("Menu_Click", params)
	End If	
End Sub


#End Region

''Completely remove the named view from the program.
Sub RemoveView(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.RemoveView
	End If
	viewmap.Remove(name)
End Sub

''Add a MenuItem to the Activity.
''The maximum of six menu itemsthat was present in previous versions no longer applies
Sub AddMenuItem(menutext As String)
		Activity.AddMenuItem(menutext, "Menu")
End Sub

''Add a Button to the window or a panel.
Sub AddButton(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim b As Button
	b.Initialize("Button")
	b.Tag = name
	AddView(b, name, left, top, width, height, parent)
End Sub

'Call the script "Sub button_click(sender)" when any Button Click event is raised. 
Sub Button_Click
	Dim v As View
	v = Sender	
	Dim params(1) As String
	params(0) = v.Tag
	Blib.Call("button_click", params)
End Sub

''Add a ToggleButton to the window or a panel.
Sub AddToggleButton(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim b As ToggleButton
	b.Initialize("ToggleButton")
	b.Tag = name	
	AddView(b, name, left, top, width, height, parent)
End Sub

'Call the script "Sub toggle_change(sender, checked)" when any ToggleButton CheckedChanged event is raised 
Sub ToggleButton_CheckedChange(Checked As Boolean)
	Dim v As View
	v = Sender	
	Dim params(2) As String
	params(0) = v.Tag
	params(1) = Checked
	Blib.Call("toggle_change", params)
End Sub

''Add a CheckBox to the window.
Sub AddCheckBox(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim b As CheckBox
	b.Initialize("CheckBox")
	b.Tag = name	
	AddView(b, name, left, top, width, height, parent)
End Sub

'Call the script "Sub check_change(sender, checked)" when any CheckBox CheckedChanged event is raised 
Sub CheckBox_CheckedChange(Checked As Boolean)
	Dim v As View
	v = Sender	
	Dim params(2) As String
	params(0) = v.Tag
	params(1) = Checked
	Blib.Call("check_change", params)
End Sub

''Add an EditText to the window or a panel.
Sub AddEditText(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim e As EditText
	e.Initialize("EditText")
	e.Tag = name
	e.Gravity = Gravity.NO_GRAVITY
	AddView(e, name, left, top, width, height, parent)
End Sub

'Call the script "Sub edit_change(sender, oldtext, newtext)" when any EditText TextChanged event is raised 
Sub EditText_TextChanged (Old As String, New As String)
	Dim v As View
	v = Sender	
	Dim params(3) As String
	params(0) = v.Tag
	params(1) = Old
	params(2) = New	
	Blib.Call("edit_change", params)
End Sub	

'Call the script "Sub edit_enterpressed(sender)" when any EditText EnterPressed event is raised 
Sub EditText_EnterPressed(Old As String, New As String)
	Dim v As View
	v = Sender	
	Dim params(1) As String
	params(0) = v.Tag
	Blib.Call("edit_enterpressed", params)
End Sub	

''Add an ImageView to the window or a panel.
Sub AddImage(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim I As ImageView
	I.Initialize("Image")
	I.Tag = name	
	AddView(I, name, left, top, width, height, parent)
	viewmap.Put(name, I)
End Sub

''Add a Label to the window or a panel.
Sub AddLabel(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim l As Label
	l.Initialize("Label")
	l.Tag = name	
	AddView(l, name, left, top, width, height, parent)
End Sub

''Add a ListView to the window or a panel.
Sub AddListView(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim S As ListView
	S.Initialize("ListView")
	S.Tag = name	
	AddView(S, name, left, top, width, height, parent)
End Sub

'Call the script "Sub listview_itemclick(sender, position, value)" when any ListView ItemClick event is raised 
Sub ListView_ItemClick(position As Int, value As Object)
	Dim v As View
	v = Sender	
	Dim params(3) As String
	params(0) = v.Tag
	params(1) = position
	params(2) = value
	Blib.Call("listview_itemclick", params)
End Sub

''Add a Panel to the window or a panel.
Sub AddPanel(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim p As Panel
	p.Initialize("Panel")
	p.Tag = name	
	AddView(p, name, left, top, width, height, parent)
End Sub

''Add a RadioButton to the window or a panel.
Sub AddRadioButton(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim b As RadioButton
	b.Initialize("RadioButton")
	b.Tag = name	
	AddView(b, name, left, top, width, height, parent)
End Sub

'Call the script "Sub radio_change(sender, checked)" when any RadioButton CheckedChanged event is raised 
Sub RadioButton_CheckedChange(Checked As Boolean)
	Dim v As View
	v = Sender	
	Dim params(2) As String
	params(0) = v.Tag
	params(1) = Checked
	Blib.Call("radio_change", params)
End Sub

''Add a ScrollView to the window or a panel.
Sub AddScrollView(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim S As ScrollView
	S.Initialize(height)
	S.Tag = name	
	AddView(S, name, left, top, width, height, parent)
End Sub

''Add a SeekBar to the window or a panel.
Sub AddSeekBar(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim S As SeekBar
	S.Initialize("SeekBar")
	S.Tag = name	
	AddView(S, name, left, top, width, height, parent)
End Sub

'Call the script "Sub seekbar_valuechanged(sender, value, userchanged)" when any SeekBar ValueChanged event is raised 
Sub SeekBar_ValueChanged(value As Int, userchanged As Boolean)
	Dim v As View
	v = Sender	
	Dim params(3) As String
	params(0) = v.Tag
	params(1) = value
	params(2) = userchanged
	Blib.Call("seekbar_valuechanged", params)
End Sub

''Add a Spinner to the window or a panel.
Sub AddSpinner(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim S As Spinner
	S.Initialize("Spinner")
	S.Tag = name	
	AddView(S, name, left, top, width, height, parent)
End Sub

'Call the script "Sub spinner_itemclick(sender, position, value)" when any Spinner ItemClick event is raised 
Sub Spinner_ItemClick(position As Int, value As Object)
	Dim v As View
	v = Sender	
	Dim params(3) As String
	params(0) = v.Tag
	params(1) = position
	params(2) = value
	Blib.Call("spinner_itemclick", params)
End Sub

''Add a TabHost to the window or a panel.
Sub AddTabHost(name As String, left As String, top As String, width As String, height As String, parent As String)
	Dim T As TabHost
	T.Initialize("TabHost")
	T.Tag = name	
	AddView(T, name, left, top, width, height, parent)
End Sub

'Call the script "Sub tabhost_tabchanged(Sender)" when any TabHost TabChanged event is raised 
Sub TabHost_TabChanged
	Dim v As TabHost
	v = Sender	
	Dim params(1) As String
	params(0) = v.Tag
	Blib.Call("tabhost_tabchanged", params) ''Sub tabhost_tabchanged(who)
End Sub

#End Region

#Region View functions
''<a href="#top">Contents</a>
''<a name="view"></a>
''VIEW FUNCTIONS
''
''Get the Enabled property of the named view.
Sub GetEnabled(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Enabled
	End If
End Sub

''Get the Visible property of the named view.
Sub GetVisible(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Visible
	End If
End Sub

''Get the Top property of the named view.
Sub GetTop(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Top
	End If
End Sub

''Get the Left property of the named view.
Sub GetLeft(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Left
	End If
End Sub

''Get the Width property of the named view.
Sub GetWidth(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Width
	End If
End Sub

''Get the Height property of the named view.
Sub GetHeight(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Height
	End If
End Sub

''Set the Enabled property of the named view.
Sub SetEnabled(name As String, state As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.Enabled = state
	End If
End Sub

''Set the Visible property of the named view.
Sub SetVisible(name As String, visible As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.visible = visible
	End If
End Sub

''Set the Top property of the named view.
Sub SetTop(name As String, top As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.top = top
	End If
End Sub

''Set the Left property of the named view.
Sub SetLeft(name As String, left As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.left = left
	End If
End Sub

''Set the Width property of the named view.
Sub SetWidth(name As String, width As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.width = width
	End If
End Sub

''Set the Height property of the named view.
Sub SetHeight(name As String, height As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.height = height
	End If
End Sub

''Bring the named view to the front of the Z order.
Sub BringToFront(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.BringToFront
	End If
End Sub

''Send the named view to the back of the Z order.
Sub SendToBack(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.SendToBack
	End If
End Sub

''Set the focus to  the named view.
Sub RequestFocus(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.RequestFocus
	End If
End Sub

''Set the BackgroundImage of the view to the present bitmap.
''Return true if both view and bitmap are initialised otherwise return false.
Sub SetBackgroundImage(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND bmp.IsInitialized Then
		v.SetBackgroundImage(bmp)
		Return True
	End If
	Return False
End Sub

''Set the Background property of the named view to a ColorDrawable.
Sub SetColor(name As String, radius As String, Color As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Dim C As ColorDrawable
		C.Initialize(Color, radius)
		v.Background = C
	End If
End Sub

''Set the Background property of the named view to a GradientDrawable.
''Returns false if less than two colors are in the array or name not found otherwise returns true.
''Orientation can be one of the following - 
''"TOP_BOTTOM", "TR_BL" (Top-Right To Bottom-Left, "RIGHT_LEFT", "BR_TL" (Bottom-Right To Top-Left)
''"BOTTOM_TOP", "BL_TR" (Bottom-Left To Top-Right), "LEFT_RIGHT", "TL_BR" (Top-Left To Bottom-Right)
Sub SetBackground(name As String, orientation As String, radius As String, colorsarrayname As String)
	Dim v As View
	Dim cols(0) As String
	Dim G As GradientDrawable
	v = viewmap.Get(name)
	cols = Blib.GetArray(colorsarrayname)
	If v.IsInitialized AND cols.Length >= 2 Then
		Dim colints(cols.Length) As Int
		For I = 0 To cols.Length - 1
			colints(I) = cols(I)
		Next
		G.Initialize(orientation, colints)
		G.CornerRadius = radius
		v.Background = G
		Return True
	End If
	Return False
End Sub

''Invalidate the named view
Sub Invalidate(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.Invalidate
	End If
End Sub

#End Region

#Region TextView functions
''<a href="#top">Contents</a>
''<a name="textview"></a>
''TEXTVIEW FUNCTIONS
''
''Views containing text support these functions in addition to the View functions.
''

''Set the Gravity property, if any, of the named view.
''NO_GRAVITY = 0; TOP = 48 (0x30) ; BOTTOM = 80 (0x50; LEFT = 3; RIGHT = 5; CENTER = 17 (0x11);
''CENTER_HORIZONTAL = 1; CENTER_VERTICAL = 16 (0x10) ; FILL = 119 (0x77); 
Sub SetGravity(name As String, gravityvalue As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Label Then
		Dim l As Label
		l = v
		l.Gravity = gravityvalue			
	End If
End Sub

''Get the Text property, if any, of the named view.
Sub GetText(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Label Then
		Dim l As Label
		l = v
		Return l.Text
	End If
End Sub

''Set the Text property, if any, of the named view.
Sub SetText(name As String, Text As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Label Then
		Dim l As Label
		l = v
		l.Text = Text			
	End If
End Sub

''Set the TextColor property, if any, of the named view.
Sub SetTextColor(name As String, Color As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Label Then
		Dim l As Label
		l = v
		l.TextColor = Color
	End If
End Sub

''Set the TextSize property, if any, of the named view.
Sub SetTextSize(name As String, size As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Label Then
		Dim l As Label
		l = v
		l.TextSize = size	
	End If
End Sub

''There is one Typeface but it can be reinitialised as required.
''Typeface - "Default", "Monospace", "Serif", "Sans_Serif"
''Style - 0 Normal : 1 Bold : 2 Italic : 3 Bold_Italic
Sub CreateTypeface(face As String, style As String)
	face = face.ToLowerCase
	If face = "monospace" Then
		font = Typeface.CreateNew(Typeface.MONOSPACE, style)
	Else If face = "serif" Then
		font = Typeface.CreateNew(Typeface.SERIF, style)
	Else If face = "sans_serif" Then
		font = Typeface.CreateNew(Typeface.SANS_SERIF, style)
	Else 
		font = Typeface.CreateNew(Typeface.DEFAULT, style)
	End If
End Sub

''Set the Typeface property, if any, of the named view to the current typeface.
Sub SetTypeface(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Label Then
		Dim l As Label
		l = v
		l.Typeface = font	
	End If
End Sub

#End Region

#Region EditText functions
''<a href="#top">Contents</a>
''<a name="edittext"></a>
''EDITTEXT FUNCTIONS
''
''EditText supports these functions in addition to the View and TextView functions.
''
''Gets the selection start position (or the cursor position) of the EditText.
''Returns -1 if there is no selection or cursor.
Sub GetSelectionStart(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		Return e.SelectionStart		
	End If
End Sub


''Force the EditText virtual keyboard action key to display Done by setting this value to True.
Sub SetForceDoneButton(name As String, forcestate As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.ForceDoneButton = forcestate			
	End If
	
End Sub

''Set the text that will appear when the EditText is empty.
Sub SetHint(name As String, hint As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.hint = hint			
	End If
	
End Sub

''Set the color of the text that will appear when the EditText is empty.
Sub SetHintColor(name As String, hintcolor As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.hintcolor = hintcolor			
	End If
End Sub

''Set the value of the EditText InputType property.
''NONE = 0; TEXT = 1; NUMBERS = 2; _PHONE = 3; DECIMAL_NUMBERS = 12290;
Sub SetInputType(name As String, inputtype As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.inputtype = inputtype			
	End If
End Sub

''Set the value of the EditText PasswordMode property.
Sub SetPasswordMode(name As String, state As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.PasswordMode = state			
	End If
End Sub

''Sets the selection start position (or the cursor position) of the EditText.
Sub SetSelectionStart(name As String, selectionstart As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.selectionstart = selectionstart			
	End If
End Sub

''Set the value of the EditText SingleLine property.
Sub SetSingleLine(name As String, state As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.SingleLine = state			
	End If
End Sub

''Set the value of the EditText Wrap property.
Sub SetWrap(name As String, state As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is EditText Then
		Dim e As EditText
		e = v
		e.Wrap = state			
	End If
End Sub


#End Region

#Region CheckBox, RadioButton and ToggleButton functions
''<a href="#top">Contents</a>
''<a name="check"></a>
''CHECKBOX, RADIOBUTTON AND TOGGLEBUTTON FUNCTIONS
''

''Get the Checked state of a CheckBox, RadioButton or ToggleButton.
Sub GetChecked(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is CheckBox Then
			Dim C As CheckBox
			C = v
			Return C.Checked
		Else If v Is RadioButton Then
			Dim r As RadioButton
			r = v
			Return r.Checked
		Else If v Is ToggleButton Then
			Dim T As ToggleButton
			T = v
			Return T.Checked
		End If
	End If
End Sub

''Set the Checked state of a CheckBox, RadioButton or ToggleButton.
Sub SetChecked(name As String, checked As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is CheckBox Then
			Dim C As CheckBox
			C = v
			C.checked = checked
		Else If v Is RadioButton Then
			Dim r As RadioButton
			r = v
			r.checked = checked		
		Else If v Is ToggleButton Then
			Dim T As ToggleButton
			T = v
			T.checked = checked		
		End If
	End If
End Sub

''Set the TextOn property of a ToggleButton.
Sub SetTextOn(name As String, Text As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is ToggleButton Then
		Dim b As ToggleButton
		b = v
		b.TextOn = Text			
	End If
End Sub

''Set the TextOff property property of a ToggleButton.
Sub SetTextOff(name As String, Text As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is ToggleButton Then
		Dim b As ToggleButton
		b = v
		b.TextOff = Text			
	End If
End Sub

#End Region

#Region Timer functions
''<a href="#top">Contents</a>
''<a name="timer"></a>
''TIMER FUNCTIONS
''
''There is one time and the Timer Tick events are vectored to a BasicLib sub "Sub timer_tick".
''If the Timer is enabled this event Sub must be present in the program.
''
''Enable or disable the timer.
Sub SetTimerEnabled(enabled As String)
	timer1.enabled = enabled
End Sub

''Set the timer interval in milliseconds.
Sub SetTimerInterval(interval As String)
	timer1.interval = interval
End Sub

'Call the script "Sub timer_tick" when the timer Tick event is raised 
Sub Timer_Tick
	Dim params(0) As String
	Blib.Call("timer_tick", params)
End Sub

#End Region

#Region SeekBar functions
''<a href="#top">Contents</a>
''<a name="seekbar"></a>
''SEEKBAR FUNCTIONS
''

''Returns the current SeekBar Max value.
Sub GetMax(seekbarname As String)
	Dim v As View
	v = viewmap.Get(seekbarname)
	If v.IsInitialized AND v Is SeekBar Then
		Dim S As SeekBar
		S = v
		Return S.Max
	End If
End Sub

''Returns the current SeekBar Value.
Sub GetValue(seekbarname As String)
	Dim v As View
	v = viewmap.Get(seekbarname)
	If v.IsInitialized AND v Is SeekBar Then
		Dim S As SeekBar
		S = v
		Return S.Value
	End If
End Sub

''Sets the current SeekBar Max value.
Sub SetMax(seekbarname As String, maxvalue As String)
	Dim v As View
	v = viewmap.Get(seekbarname)
	If v.IsInitialized AND v Is SeekBar Then
		Dim S As SeekBar
		S = v
		S.Max = maxvalue
	End If
End Sub

''Sets the current SeekBar Value.
Sub SetValue(seekbarname As String, value As String)
	Dim v As View
	v = viewmap.Get(seekbarname)
	If v.IsInitialized AND v Is SeekBar Then
		Dim S As SeekBar
		S = v
		S.value = value
	End If
End Sub

#End Region

#Region ScrollView functions
''<a href="#top">Contents</a>
''<a name="scrollview"></a>
''SCROLLVIEW FUNCTIONS
''

''Returns the current ScrollView ScrollPosition.
Sub GetScrollPosition(scrollviewname As String)
	Dim v As View
	v = viewmap.Get(scrollviewname)
	If v.IsInitialized AND v Is ScrollView Then
		Dim S As ScrollView
		S = v
		Return S.ScrollPosition
	End If
End Sub

''Sets the current ScrollView ScrollPosition.
Sub SetScrollPosition(scrollviewname As String, value As String)
	Dim v As View
	v = viewmap.Get(scrollviewname)
	If v.IsInitialized AND v Is ScrollView Then
		Dim S As ScrollView
		S = v
		S.ScrollPosition = value
	End If
End Sub

''Scrolls the ScrollView to the top or bottom.
Sub FullScroll(scrollviewname As String, bottom As String)
	Dim v As View
	v = viewmap.Get(scrollviewname)
	If v.IsInitialized AND v Is ScrollView Then
		Dim S As ScrollView
		S = v
		S.FullScroll(bottom)
	End If
End Sub

''Makes the ScrollView Panel accessible as a named Panel View.
Sub GetPanel(scrollviewname As String, panelname As String)
	Dim v As View
	v = viewmap.Get(scrollviewname)
	If v.IsInitialized AND v Is ScrollView Then
		Dim S As ScrollView
		S = v
		viewmap.Put(panelname, S.Panel)
	End If
End Sub

#End Region

#Region Spinner functions
''<a href="#top">Contents</a>
''<a name="spinner"></a>
''SPINNER FUNCTIONS
''

''Sets the title that will be displayed when the Spinner is opened.
Sub SetPrompt(name As String, index As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized  AND v Is Spinner Then
		Dim S As Spinner
		S = v
		S.Prompt = index
	End If
End Sub

''Returns the index of the selected item of a Spinner. Returns -1 if no item is selected.
Sub GetSelectedIndex(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Spinner Then
		Dim S As Spinner
		S = v
		Return S.SelectedIndex
	End If
End Sub

''Selects the item at the specified index of a Spinner. Pass -1 if no item is selected.
Sub SetSelectedIndex(name As String, index As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Spinner Then
		Dim S As Spinner
		S = v
		S.SelectedIndex = index
	End If
End Sub

''Returns the the selected item of a Spinner. Returns "" if no item is selected.
Sub GetSelectedItem(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is Spinner Then
		Dim S As Spinner
		S = v
		Return S.SelectedItem
	End If
End Sub

#End Region

#Region ListView functions
''<a href="#top">Contents</a>
''<a name="listview"></a>
''LISTVIEW FUNCTIONS
''

''Sets the background color that will be used while scrolling the ListView.
Sub SetScrollColor(name As String, Color As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is ListView Then
		Dim l As ListView
		l = v
		l.ScrollingBackgroundColor = Color		
	End If
End Sub

''Sets whether the fast scroll icon will appear when the user scrolls the list. The default Is False.
Sub SetFastScrollEnabled(name As String, state As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is ListView Then
		Dim l As ListView
		l = v
		l.FastScrollEnabled = state		
	End If
End Sub

''Sets the ItemHeight of the SingleLineLayout in a ListView.
Sub SetItemHeight(name As String, height As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is ListView Then
		Dim l As ListView
		l = v
		l.SingleLineLayout.ItemHeight = height		
	End If
End Sub

''Makes the ListView.SingleLineLayout.Label accessible as a Label view.
''The layout functions of the ListView items may be changed using the label functions.
Sub GetLabel(listviewname As String, labelname As String)
	Dim v As View
	v = viewmap.Get(listviewname)
	If v.IsInitialized AND v Is ListView Then
		Dim l As ListView
		l = v
		viewmap.Put(labelname, l.SingleLineLayout.Label)
	End If
End Sub

''Set the ListView.SingleLineLayout.Background property of the ListView to a ColorDrawable.
Sub SetLayoutBackgroundColor(name As String, radius As String, Color As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized AND v Is ListView Then
		Dim C As ColorDrawable
		C.Initialize(Color, radius)
		Dim l As ListView
		l.SingleLineLayout.Background = C
	End If
End Sub

''Set the ListView.SingleLineLayout.Background property of the ListView to a GradientDrawable.
''Returns false if less than two colors are in the array or name not found otherwise returns true.
''Orientation can be one of the following - 
''"TOP_BOTTOM", "TR_BL" (Top-Right To Bottom-Left, "RIGHT_LEFT", "BR_TL" (Bottom-Right To Top-Left)
''"BOTTOM_TOP", "BL_TR" (Bottom-Left To Top-Right), "LEFT_RIGHT", "TL_BR" (Top-Left To Bottom-Right)
Sub SetLayoutBackgroundColorgradient(name As String, orientation As String, radius As String, colorsarrayname As String)
	Dim cols(0) As String
	Dim v As View
	v = viewmap.Get(name)
	cols = Blib.GetArray(colorsarrayname)
	If v.IsInitialized AND v Is ListView AND cols.Length >= 2 Then
		Dim l As ListView
		Dim G As GradientDrawable
		Dim colints(cols.Length) As Int
		For I = 0 To cols.Length - 1
			colints(I) = cols(I)
		Next
		G.Initialize(orientation, colints)
		G.CornerRadius = radius
		l = v
		l.SingleLineLayout.Background = G
		Return True
	End If
	Return False
End Sub

#End Region

#Region ListView and Spinner functions
''<a href="#top">Contents</a>
''<a name="listandspin"></a>
''LISTVIEW AND SPINNER FUNCTIONS
''

''Add an item To a ListView or Spinner.
Sub Add(name As String, item As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			S.Add(item)
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			l.AddSingleLine(item)		
		End If
	End If
End Sub

''Add an array of items to a ListView or Spinner.
Sub AddAll(name As String, itemarrayname As String)
	Dim v As View
	Dim ia(0) As String
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			ia = Blib.GetArray(itemarrayname)
			S.AddAll(ia)
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			ia = Blib.GetArray(itemarrayname)
			For I = 0 To ia.Length - 1
				l.AddSingleLine(ia(I))
			Next
		End If
	End If
End Sub

''Clears the items from a ListView or Spinner.
Sub Clear(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			S.Clear
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			l.Clear
		End If
	End If
End Sub

''Returns the item at the specified index from a ListView or Spinner.
Sub GetItem(name As String, index As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			Return S.GetItem(index)
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			Return l.GetItem(index)
		End If
	End If
End Sub

''Removes the item at the specified index from a ListView or Spinner.
Sub RemoveAt(name As String, index As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			S.RemoveAt(index)
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			l.RemoveAt(index)
		End If
	End If
End Sub

''Returns the number of items in a ListView or Spinner.
Sub GetSize(name As String, index As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		If v Is Spinner Then
			Dim S As Spinner
			S = v
			Return S.Size
		Else If v Is ListView Then
			Dim l As ListView
			l = v
			Return l.Size
		End If
	End If
End Sub

#End Region

#Region TabHost functions
''<a href="#top">Contents</a>
''<a name="tabhost"></a>
''TABHOST
''

''Add a Tab and a new associated Panel to a TabHost.
''The panelname may be used to add views To the Tab.
Sub AddTab(title As String, panelname As String, parenttabhost As String)
	Dim v As View
	v = viewmap.Get(parenttabhost)
	If v.IsInitialized AND v Is TabHost Then
		Dim T As TabHost
		T = v
		Dim p As Panel
		p.Initialize("Panel")
		p.Tag = panelname	
		viewmap.Put(panelname, p)			
		T.AddTab2(title, p)
	End If
End Sub

''Returns the number of tab pages.
Sub GetTabCount(tabhostname As String)
	Dim v As View
	v = viewmap.Get(tabhostname)
	If v.IsInitialized AND v Is TabHost Then
		Dim T As TabHost
		T = v
		Return T.TabCount
	End If
End Sub

''Returns the index of the current tab page.
Sub GetCurrentTab(tabhostname As String)
	Dim v As View
	v = viewmap.Get(tabhostname)
	If v.IsInitialized AND v Is TabHost Then
		Dim T As TabHost
		T = v
		Return T.CurrentTab
	End If
End Sub

''Selects the current tab page.
Sub SetCurrentTab(tabhostname As String, tabnumber As String)
	Dim v As View
	v = viewmap.Get(tabhostname)
	If v.IsInitialized AND v Is TabHost Then
		Dim T As TabHost
		T = v
		T.CurrentTab = tabnumber
	End If
End Sub

#End Region

#Region Graphics functions
''<a href="#top">Contents</a>
''<a name="graphics"></a>
''GRAPHICS FUNCTIONS
''

''There is one bitmap but it can be reinitialised to a bitmap from a file.
Sub BitmapInit(dir As String, fileName As String)
	bmp.Initialize(dir, fileName)
End Sub

''The one bitmap can also be reinitialised to a mutable bitmap.
Sub BitmapInitMutable(width As String, height As String)
	bmp.InitializeMutable(width, height)
End Sub

''Get the width of the current bitmap.
Sub BitmapWidth
	Return bmp.Width
End Sub

''Get the height of the current bitmap.
Sub BitmapHeight
	Return bmp.Height
End Sub

''There is one canvas but it can be reinitialised on any View.
Sub CanvasInit(imageviewname As String)
	Dim v As View
	v = viewmap.Get(imageviewname)
	If v.IsInitialized Then
		draw.Initialize(v)
	End If
End Sub

''The one canvas can also be reinitialised on a mutable Bitmap if the sole Bitmap object is one.
Sub CanvasInit2()
	Dim v As View
	If bmp.IsInitialized Then
		draw.Initialize2(bmp)
	End If
End Sub

''Draws the present bitmap
''SrcRect - The subset of the Bitmap that will be drawn.
''DestRect - The rectangle that the Bitmap will be drawn to.
''Returns false if more or less than two points are in the rectangle arrays otherwise returns true.
Sub DrawBitmap(srcrectarrayname As String, destrectarrayname As String)
	Dim rsrc As Rect
	Dim rdest As Rect
	Dim rs(0) As String
	Dim rd(0) As String
	rs = Blib.GetArray(srcrectarrayname)
	rd = Blib.GetArray(destrectarrayname)
	If rs.Length <> 4 OR rd.Length <> 4 Then
		Return False
	End If
	rsrc.Initialize(rs(0), rs(1), rs(2), rs(3))
	rdest.Initialize(rd(0), rd(1), rd(2), rd(3))
	draw.DrawBitmap(bmp, rsrc, rdest)
	Return True
End Sub

''Draws the present bitmap rotated.
''SrcRect - The subset of the Bitmap that will be drawn.
''DestRect - The rectangle that the Bitmap will be drawn to.
''Returns false if more or less than two points are in the rectangle arrays otherwise returns true.
Sub DrawBitmapRotated(srcrectarrayname As String, destrectarrayname As String, degrees As String)
	Dim rsrc As Rect
	Dim rdest As Rect
	Dim rs(0) As String
	Dim rd(0) As String
	rs = Blib.GetArray(srcrectarrayname)
	rd = Blib.GetArray(destrectarrayname)
	If rs.Length <> 4 OR rd.Length <> 4 Then
		Return False
	End If
	rsrc.Initialize(rs(0), rs(1), rs(2), rs(3))
	rdest.Initialize(rd(0), rd(1), rd(2), rd(3))
	draw.DrawBitmapRotated(bmp, rsrc, rdest, degrees)
	Return True
End Sub

''Fills the entire canvas with the given color.
Sub DrawColor(Color As String)
	draw.DrawColor(Color)
End Sub

''Draws a circle.
Sub DrawCircle(x As String, y As String, radius As String, Color As String, filled As String, strokewidth As String)
	draw.DrawCircle(x, y, radius, Color, filled, strokewidth)
	End Sub

''Draws a line.
Sub DrawLine(x1 As String, y1 As String, x2 As String, y2 As String, Color As String, strokewidth As String)
	draw.DrawLine(x1, y1, x2, y2, Color, strokewidth)
End Sub

''Draws a set of connected lines from the points provided in a named array.
''Returns false if less than two points are in the array otherwise returns true.
Sub DrawPath(pointsarrayname As String, Color As String, filled As String, strokewidth As String)
	Dim p As Path
	Dim pts(0) As String
	pts = Blib.GetArray(pointsarrayname)
	If pts.Length < 4 Then
		Return False
	End If
	p.Initialize(pts(0), pts(1))
	For I = 2 To pts.Length - 2 Step 2
		p.LineTo(pts(I), pts(I + 1))
	Next
	draw.DrawPath(p, Color, filled, strokewidth)
	Return True
End Sub

''Sets a single pixel to the specified color.
Sub DrawPoint(x As String, y As String, Color As String)
	draw.DrawPoint(x, y, Color)
End Sub

''Draws a rectangle from the points provided in a named array.
''Returns false if more or less than two points are in the array otherwise returns true.
Sub DrawRect(rectarrayname As String, Color As String, filled As String, strokewidth As String)
	Dim r As Rect
	Dim ra(0) As String
	ra = Blib.GetArray(rectarrayname)
	If ra.Length <> 4 Then
		Return False
	End If
	r.Initialize(ra(0), ra(1), ra(2), ra(3))
	draw.DrawRect(r, Color, filled, strokewidth)
	Return True
End Sub

''Draws a rotated rectangle from the points provided in a named array.
''Returns false if more or less than two points are in the array otherwise returns true.
Sub DrawRectRotated(rectarrayname As String, Color As String, filled As String, strokewidth As String, degrees As String)
	Dim r As Rect
	Dim ra(0) As String
	ra = Blib.GetArray(rectarrayname)
	If ra.Length <> 4 Then
		Return False
	End If
	r.Initialize(ra(0), ra(1), ra(2), ra(3))
	draw.DrawRectRotated(r, Color, filled, strokewidth, degrees)
	Return True
End Sub

''Draw text. Align is one of the following values: "LEFT", "CENTER", "RIGHT".
Sub DrawText(Text As String, x As String, y As String, textsize As String, Color As String, align As String)
	draw.DrawText(Text, x, y, font, textsize, Color, align.ToUpperCase)
End Sub

''Draw text. Align is one of the following values: "LEFT", "CENTER", "RIGHT".
Sub DrawTextRotated(Text As String, x As String, y As String, textsize As String, Color As String, align As String, degrees As String)
	draw.DrawTextRotated(Text, x, y, font, textsize, Color, align.ToUpperCase, degrees)
End Sub

#End Region

#Region Array Functions
''<a href="#top">Contents</a>
''<a name="arrays"></a>
''ARRAY FUNCTIONS
''

''Fully or partially fills the specified array with the specified value.
Sub FillArray(arrayname As String, start As String, len As String, value As String)
	Dim ia(0) As String
	ia = Blib.GetArray(arrayname)
	arraysX.Fill(ia, start, len, value)
	Blib.ShareArray(arrayname, ia)
End Sub

''Sort the specified array into ascending order in the specified manner. 
''SORTCASESENSITIVE is 0, SORTCASEINSENSITIVE is 1, SORTNUMERIC = 2
''Note that for use with BinarySearch SORTCASESENSITIVE should be used otherwise the result may not be accurate
Sub SortArray(arrayname As String, sorttype As String)
	Dim ia(0) As String
	ia = Blib.GetArray(arrayname)
	arraysX.SortStringArray(ia, sorttype)
	Blib.ShareArray(arrayname, ia)
End Sub

''Searches the specified array for the specified value using the binary search algorithm.
''The array must be sorted into ascending order using SORTCASESENSITIVE otherwise the result may not be accurate
Sub SearchArray(arrayname As String, value As String)
	Dim ia(0), res As String
	ia = Blib.GetArray(arrayname)
	res = arraysX.BinarySearch(ia, value)
	Return res
End Sub



#End Region

#Region User interaction functions
''<a href="#top">Contents</a>
''<a name="user"></a>
''USER INTERACTION FUNCTIONS
''

''Shows a Toast.
Sub ShowToast(msg As String, longtime As String)
	ToastMessageShow(msg, longtime)
End Sub

''Get the user input from the latest InputBox, InputDate or InputTime modal dialog. 
Sub GetInput
	Return input
End Sub

''Show a modal dialog box and prompt the user for data.
''Returns a DialogResponse value with the input text available to GetInput.
Sub InputBox(prompt As String, title As String, Positive As String, Cancel As String, Negative As String)
	Dim I As InputDialog
	response = I.Show(prompt, title, Positive, Cancel, Negative, Null)
	input = I.input
	Return response	
End Sub

''Show a modal dialog box and prompt the user for a date.
''Returns a DialogResponse value with the input value avalable to GetInput as a ticks value.
Sub InputDate(prompt As String, title As String, startdateticks As String, Positive As String, Cancel As String, Negative As String)
	Dim d As DateDialog
	d.DateTicks = startdateticks 
	response = d.Show(prompt, title, Positive, Cancel, Negative, Null)
	input = d.DateTicks
	Return response	
End Sub

''Show a modal dialog box and prompt the user for a path or file name.
''Returns a DialogResponse value with the input values available to GetInput as a  comma separated string.
''The first part is the file path and the last part is file name. If the user selected a path the file name is an  empty string.
Sub InputFile(filepath As String, filename As String, filefilter As String, title As String, Positive As String, Cancel As String, Negative As String)
	Dim f As FileDialog	
	f.filepath = filepath
	f.ChosenName = filename
	f.filefilter = filefilter
	response = f.Show(title, Positive, Cancel, Negative, Null)
	input = f.filepath & "," & f.ChosenName
	Return response	
End Sub

''Show a modal dialog box and prompt the user for a time.
''Returns a DialogResponse value with the input value available to GetInput as a ticks value.
Sub InputTime(prompt As String, title As String, starttimeticks As String, as24hrs As String, Positive As String, Cancel As String, Negative As String)
	Dim T As TimeDialog
	T.TimeTicks = starttimeticks
	T.Is24Hours = as24hrs
	response = T.Show(prompt, title, Positive, Cancel, Negative, Null)
	input = T.TimeTicks
	Return response	
End Sub

''Show a modal dialog box and prompt the user to select an item.
''selecteditem is the index of the item that will first be selected or -1 if no item should be preselected.
''Returns the index of the selected item or DialogResponse.Cancel if the user pressed on the back key.
Sub InputListBox(itemarrayname As String, title As String, selecteditem As String )
	Dim l As List
	l.Initialize
	Dim ia(0) As String
	ia = Blib.GetArray(itemarrayname)
	For I = 0 To ia.Length - 1
		l.Add(ia(I))
	Next
	Return InputList(l, title, selecteditem) 	
End Sub

''Show a modal dialog box and prompt the user to select one or more items.
''returns a comma separated list of indices selected that may be separated with StrSplit.
Sub InputMultiListBox(itemarrayname As String, title As String)
	Dim l As List	
	l.Initialize
	Dim ia(0) As String
	ia = Blib.GetArray(itemarrayname)
	For I = 0 To ia.Length - 1
		l.Add(ia(I))
	Next
	l = InputMultiList(l, title)
	ret = ""
	comma = ""
	For I = 0 To l.Size - 1
		ret = ret & comma & l.Get(I)
		comma = ","
	Next
	Return ret
End Sub

''Show a modal dialog box and prompt the user for an integer number.
''If ShowSign is True the sign of the number corresponds to the sign entered by the user.
''Returns a DialogResponse value with the input number available to GetInput.
''If ShowSign is True the sign of the number corresponds to the sign entered by the user.
Sub InputNumber(showsign As String, digits As String, number As String, title As String, Positive As String, Cancel As String, Negative As String)
	Dim n As NumberDialog
	n.showsign = showsign
	n.digits = digits
	n.number = number
	response = n.Show(title, Positive, Cancel, Negative, Null)
	input = n.number
	Return response	
End Sub

''Show a modal dialog box and prompt the user to make a selection.
''Returns a DialogResponse
Sub MessageBox(message As String, title As String, Positive As String, Cancel As String, Negative As String)
	response = Msgbox2(message, title, Positive, Cancel, Negative, Null)
	Return response	
End Sub

''Show a non-modal progress dialog.
Sub ProgressShow(Text As String)
	ProgressDialogShow(Text)
End Sub

''Hide a non-modal progress dialog.
Sub ProgressHide
	ProgressDialogHide
End Sub

''Allow the message loop to run, lets the progress dialog repaint itself.
Sub CallDoEvents
	DoEvents
End Sub

#End Region

#Region File operation functions
''<a href="#top">Contents</a>
''<a name="file"></a>
''FILE OPERATION FUNCTIONS
''

''Reads the entire file and fills a named array with all lines as strings.
''Returns true if successful, false otherwise.
Sub FileReadList(dir As String, fileName As String, listarrayname As String)
	Try
		Dim l As List
		l = File.ReadList(dir, fileName)
		Dim A(l.Size) As String
		For I = 0 To A.Length - 1
			A(I) = l.Get(I)
		Next
		Blib.SetArray(listarrayname, A)
		Return True
	Catch
		Return False
	End Try
End Sub

''Reads the entire file and returns it as a string.
''Returns an empty string on failure.
Sub FileReadString(dir As String, fileName As String)
	Try
		Return File.ReadString(dir, fileName)
	Catch
		Return ""
	End Try
End Sub

''Writes each item in the List As a single line.
''Note that a value containing CRLF will be saved as two lines which will return two items when read with ReadList.
''Returns true if successful, false otherwise.
Sub FileWriteList(dir As String, filename As String, listarrayname As String)
	Try
		Dim A(0) As String
		A = Blib.GetArray(listarrayname)
		File.WriteList(dir, filename, A)
		Return True
	Catch
		Return False
	End Try
End Sub

''Writes the given text to a new file.
''Returns true if successful, false otherwise.
Sub FileWriteString(dir As String, filename As String, Text As String)
	Try
		File.WriteString(dir, filename, Text)
		Return True
	Catch
		Return False
	End Try
End Sub

''Deletes the specified file. If the file name is a directory then it must be empty in order to be deleted.
''Returns true if the file was successfully deleted.
''Files in the assets folder cannot be deleted.
''Returns true if successful, false otherwise.
Sub FileDelete(dir As String, filename As String)
	Try
		Return File.Delete(dir, filename)
	Catch
		Return False
	End Try	
End Sub

''Returns true if the specified FileName exists in the specified Dir.
''Note that the Android file system is case sensitive.
Sub FileExists(dir As String, filename As String)
	Return File.Exists(dir, filename)
End Sub

''Tests whether the specified file is a directory.
Sub FileIsDirectory(dir As String, filename As String)
	Return File.IsDirectory(dir, filename)
End Sub

''Creates the given folder (dir can be a path like "dir1/dir2", creates all folders as needed).
''Returns true if successful, false otherwise.
Sub FileMakeDir(parentdir As String, dir As String)
	Try
		File.MakeDir(parentdir, dir)
		Return True
	Catch
		Return False
	End Try
End Sub 

''Fills an array with a list with all the files and directories which are stored in the specified path.
''Returns true if successful, false otherwise.
Sub FileListFiles(dir As String, filesarrayname As String)
	Try
		Dim l As List
		l = File.ListFiles(dir)
		Dim A(l.Size) As String
		For I = 0 To A.Length - 1
			A(I) = l.Get(I)
		Next
		Blib.SetArray(filesarrayname, A)	
		Return True
	Catch
		Return False
	End Try
End Sub

''Returns the internal private storage dir.
Sub FileDirInternal As String
	If Main.IDEMode Then
		If Main.ProjectDir.Length > 0 Then
			File.MakeDir(File.DirInternal, Main.ProjectDir)
			Return File.DirInternal & "/" & Main.ProjectDir		
		Else
			File.MakeDir(File.DirInternal, "ScriptsData")
			Return File.DirInternal & "/ScriptsData"
		End If
	Else
		Return File.DirInternal
	End If
End Sub

''Returns the root folder of the external storage media.
Sub FileDirRootExternal
	Return File.DirRootExternal
End Sub

''Returns the application default external folder which is based on the package name.
''The folder is created if needed.
Sub FileDirDefaultExternal
	If Main.IDEMode AND Main.ProjectDir.Length > 0 Then
		Return File.DirDefaultExternal & "/" & Main.ProjectDir
	Else
		Return File.DirDefaultExternal
	End If
End Sub

''Returns a reference to the files added with the Files Manager. These files are read-only.
Sub FileDirAssets
	If Main.IDEMode Then
		If Main.ProjectPath.Length > 0 Then
			Return Main.ProjectPath
		Else
			Return Main.IdePath
		End If
	Else
		Return File.DirAssets
	End If
End Sub

''<a href="#top">Contents</a>
#End Region 

#Region Custom functions

'##########################################################################################
' Custom Subs added to be added as functions to BasicLibIDE by AddSysCalls are defined here
' -----------------------------------------------------------------------------------------

''<a href="#top">Contents</a>
''<a name="custom"></a>

''CUSTOM FUNCTIONS
''
''These additional functions have been added by B4A user JesseW to compliment the BasicLib library and extend its functionality.
''

' Call once after Blib.Initialize to add the new functions
Sub AddNewSysCalls
	Blib.AddSysCalls(Array As String("SetDefaultParams",  _
									 "AddDefaultLabel", _
									 "SetRight", _
									 "GetRight", _
									 "SetBottom", _
									 "GetBottom", _
									 "SetHCenter", _
									 "GetHCenter", _
									 "SetVCenter", _
									 "GetVCenter", _
									 "SetLeftAndRight", _
									 "SetTopAndBottom", _
									 "isView", _
									 "RemoveAllViews", _
									 "TextHeight", _
									 "isNumeric", _
									 "StrLeft", _
									 "StrMid", _
									 "StrRight", _
									 "StrTrim", _
									 "iif", _
									 "Chain", _
									 "Run", _
									 "Restart", _
									 "SetActivityTitle", _
									 "SetActivityTitleColor", _
									 "RemoveFromParent", _
									 "InputCustom", _
									 "DialogResponse_Positive", _
									 "DialogResponse_Cancel", _
									 "DialogResponse_Negative", _
									 "FileDirInternal", _
									 "Gravity_None", _
									 "Gravity_Top", _
									 "Gravity_Bottom", _
									 "Gravity_Left", _
									 "Gravity_Right", _
									 "Gravity_Center", _
									 "Gravity_CenterHorizontal", _
									 "Gravity_CenterVertical", _
									 "Gravity_Fill", _
									 "Typeface_FontDefault", _
									 "Typeface_FontMonospace", _
									 "Typeface_FontSerif", _
									 "Typeface_FontSansSerif", _
									 "Typeface_StyleNormal", _
									 "Typeface_StyleBold", _
									 "Typeface_StyleItalic", _
									 "Typeface_StyleBoldItalic", _
									 "Colors_Black", _
									 "Colors_Blue", _
									 "Colors_Cyan", _
									 "Colors_DarkGray", _
									 "Colors_Gray", _
									 "Colors_Green", _
									 "Colors_LightGray", _
									 "Colors_Magenta", _
									 "Colors_Red", _
									 "Colors_Transparent", _
									 "Colors_White", _
									 "Colors_Yellow", _
									 "KeyCode_isNumber", _
									 "KeyCode_isAlpha", _
									 "KeyCode_isSymbol", _
									 "KeyCode_isKeyboard", _
									 "KeyCode_isDPad", _
									 "KeyCode_isMedia", _
									 "KeyCode_isDevice", _
									 "KeyCode_AltLeft", _
									 "KeyCode_AltRight", _
									 "KeyCode_Back", _
									 "KeyCode_Call", _
									 "KeyCode_Camera", _
									 "KeyCode_Clear", _
									 "KeyCode_Del", _
									 "KeyCode_DPadCenter", _
									 "KeyCode_DPadDown", _
									 "KeyCode_DPadLeft", _
									 "KeyCode_DPadRight", _
									 "KeyCode_DPadUp", _
									 "KeyCode_EndCall", _
									 "KeyCode_Enter", _
									 "KeyCode_Envelope", _
									 "KeyCode_Explorer", _
									 "KeyCode_Focus", _
									 "KeyCode_Grave", _
									 "KeyCode_HeadSetHook", _
									 "KeyCode_Home", _
									 "KeyCode_MediaFastForward", _
									 "KeyCode_MediaNext", _
									 "KeyCode_MediaPlayPause", _
									 "KeyCode_MediaPrevious", _
									 "KeyCode_MediaRewind", _
									 "KeyCode_MediaStop", _
									 "KeyCode_Menu", _
									 "KeyCode_Mute", _
									 "KeyCode_Notification", _
									 "KeyCode_Num", _
									 "KeyCode_Search", _
									 "KeyCode_ShiftLeft", _
									 "KeyCode_ShiftRight", _
									 "KeyCode_SoftLeft", _
									 "KeyCode_SoftRight", _
									 "KeyCode_Sym", _
									 "KeyCode_Tab", _
									 "KeyCode_Unknown", _
									 "KeyCode_VolumeDown", _
									 "KeyCode_VolumnUp"))
End Sub

''Keycode functions:
''KeyCode_isNumber(KeyCode)
''KeyCode_isAlpha(KeyCode)
''KeyCode_isSymbol(KeyCode)
''KeyCode_isKeyboard(KeyCode)
''KeyCode_isDPad(KeyCode)
''KeyCode_isMedia(KeyCode)
''KeyCode_isDevice(KeyCode)
''--
''Pass the KeyCode value from the Activity_KeyPress event to any of these
''functions and they will return true or false depending upon whether
''the passed KeyCode is contained within that particular set.

Sub KeyCode_isNumber(KeyCode As String) As String
	Dim isnum As Boolean
	isnum = True
	Select KeyCode
		Case KeyCodes.KEYCODE_0
		Case KeyCodes.KEYCODE_1
		Case KeyCodes.KEYCODE_2
		Case KeyCodes.KEYCODE_3
		Case KeyCodes.KEYCODE_4
		Case KeyCodes.KEYCODE_5
		Case KeyCodes.KEYCODE_6
		Case KeyCodes.KEYCODE_7
		Case KeyCodes.KEYCODE_8
		Case KeyCodes.KEYCODE_9
		Case Else
			isnum = False
	End Select
	Return isnum
End Sub

Sub KeyCode_isAlpha(KeyCode As String) As String
	Dim isalpha As Boolean
	isalpha = True
	Select KeyCode
		Case KeyCodes.KEYCODE_A
		Case KeyCodes.KEYCODE_B
		Case KeyCodes.KEYCODE_C
		Case KeyCodes.KEYCODE_D
		Case KeyCodes.KEYCODE_E
		Case KeyCodes.KEYCODE_F
		Case KeyCodes.KEYCODE_G
		Case KeyCodes.KEYCODE_H
		Case KeyCodes.KEYCODE_I
		Case KeyCodes.KEYCODE_J
		Case KeyCodes.KEYCODE_K
		Case KeyCodes.KEYCODE_L
		Case KeyCodes.KEYCODE_M
		Case KeyCodes.KEYCODE_N
		Case KeyCodes.KEYCODE_O
		Case KeyCodes.KEYCODE_P
		Case KeyCodes.KEYCODE_Q
		Case KeyCodes.KEYCODE_R
		Case KeyCodes.KEYCODE_S
		Case KeyCodes.KEYCODE_T
		Case KeyCodes.KEYCODE_U
		Case KeyCodes.KEYCODE_V
		Case KeyCodes.KEYCODE_W
		Case KeyCodes.KEYCODE_X
		Case KeyCodes.KEYCODE_Y
		Case KeyCodes.KEYCODE_Z
		Case Else
			isalpha = False
	End Select
	Return isalpha
End Sub

Sub KeyCode_isSymbol(KeyCode As String) As String
	Dim issym As Boolean
	issym = True
	Select KeyCode
		Case KeyCodes.KEYCODE_APOSTROPHE
		Case KeyCodes.KEYCODE_AT
		Case KeyCodes.KEYCODE_BACKSLASH
		Case KeyCodes.KEYCODE_COMMA
		Case KeyCodes.KEYCODE_EQUALS
		Case KeyCodes.KEYCODE_LEFT_BRACKET
		Case KeyCodes.KEYCODE_MINUS
		Case KeyCodes.KEYCODE_PERIOD
		Case KeyCodes.KEYCODE_PLUS
		Case KeyCodes.KEYCODE_POUND
		Case KeyCodes.KEYCODE_POWER
		Case KeyCodes.KEYCODE_RIGHT_BRACKET
		Case KeyCodes.KEYCODE_SEMICOLON
		Case KeyCodes.KEYCODE_SLASH
		Case KeyCodes.KEYCODE_STAR
		Case Else
			issym = False
	End Select
	Return issym
End Sub

Sub KeyCode_isKeyboard(KeyCode As String) As String
	Dim iskey As Boolean
	iskey = True
	Select KeyCode
		Case KeyCodes.KEYCODE_ALT_LEFT
		Case KeyCodes.KEYCODE_ALT_RIGHT
		Case KeyCodes.KeyCode_Clear
		Case KeyCodes.KeyCode_Del
		Case KeyCodes.KeyCode_Enter
		Case KeyCodes.KeyCode_Num
		Case KeyCodes.KEYCODE_SHIFT_LEFT
		Case KeyCodes.KEYCODE_SHIFT_RIGHT
		Case KeyCodes.KEYCODE_SPACE
		Case KeyCodes.KeyCode_Sym
		Case Else
			iskey = False
	End Select
	Return iskey
End Sub

Sub KeyCode_isDPad(KeyCode As String) As String
	Dim ispad As Boolean
	ispad = True
	Select KeyCode
		Case KeyCodes.KEYCODE_DPAD_CENTER
		Case KeyCodes.KEYCODE_DPAD_DOWN
		Case KeyCodes.KEYCODE_DPAD_LEFT
		Case KeyCodes.KEYCODE_DPAD_RIGHT
		Case KeyCodes.KEYCODE_DPAD_UP
		Case Else
			ispad = False
	End Select
	Return ispad
End Sub

Sub KeyCode_isMedia(KeyCode As String) As String
	Dim ismed As Boolean
	ismed = True
	Select KeyCode
		Case KeyCodes.KEYCODE_MEDIA_FAST_FORWARD
		Case KeyCodes.KEYCODE_MEDIA_NEXT
		Case KeyCodes.KEYCODE_MEDIA_PLAY_PAUSE
		Case KeyCodes.KEYCODE_MEDIA_PREVIOUS
		Case KeyCodes.KEYCODE_MEDIA_REWIND
		Case KeyCodes.KEYCODE_MEDIA_STOP
		Case KeyCodes.KeyCode_Mute
		Case Else
			ismed = False
	End Select
	Return ismed
End Sub

Sub KeyCode_isDevice(KeyCode As String) As String
	Dim isdev As Boolean
	isdev = True
	Select KeyCode
		Case KeyCodes.KeyCode_Back
		Case KeyCodes.KeyCode_Call
		Case KeyCodes.KeyCode_Camera
		Case KeyCodes.KeyCode_EndCall
		Case KeyCodes.KeyCode_Envelope
		Case KeyCodes.KeyCode_Explorer	'not sure bout this one???
		Case KeyCodes.KeyCode_Focus		'or this one???
		Case KeyCodes.KeyCode_Grave		'have no idea bout this one???
		Case KeyCodes.KeyCode_HeadSetHook
		Case KeyCodes.KeyCode_Home
		Case KeyCodes.KeyCode_Menu
		Case KeyCodes.KeyCode_Notification
		Case KeyCodes.KeyCode_Search
		Case KeyCodes.KEYCODE_SOFT_LEFT
		Case KeyCodes.KEYCODE_SOFT_RIGHT
		Case KeyCodes.KEYCODE_VOLUME_DOWN
		Case KeyCodes.KEYCODE_VOLUME_UP
		Case Else
			isdev = False
	End Select
	Return isdev
End Sub

''KeyCode constants:
''Note that not all KeyCode constants are supported. Letters, numbers and
''symbols can all be checked for using the KeyCode functions above. These
''constants contain the remaining values.
''--
''KeyCode_AltLeft
''KeyCode_AltRight
''KeyCode_Back
''KeyCode_Call
''KeyCode_Camera
''KeyCode_Clear
''KeyCode_Del
''KeyCode_DPadCenter
''KeyCode_DPadDown
''KeyCode_DPadLeft
''KeyCode_DPadRight
''KeyCode_DPadUp
''KeyCode_EndCall
''KeyCode_Enter
''KeyCode_Envelope
''KeyCode_Explorer
''KeyCode_Focus
''KeyCode_Grave
''KeyCode_HeadSetHook
''KeyCode_Home
''KeyCode_MediaFastForward
''KeyCode_MediaNext
''KeyCode_MediaPlayPause
''KeyCode_MediaPrevious
''KeyCode_MediaRewind
''KeyCode_MediaStop
''KeyCode_Menu
''KeyCode_Mute
''KeyCode_Notification
''KeyCode_Num
''KeyCode_Search
''KeyCode_ShiftLeft
''KeyCode_ShiftRight
''KeyCode_SoftLeft
''KeyCode_SoftRight
''KeyCode_Sym
''KeyCode_Tab
''KeyCode_Unknown
''KeyCode_VolumeDown
''KeyCode_VolumnUp

Sub KeyCode_AltLeft As String
	Return KeyCodes.KEYCODE_ALT_LEFT
End Sub

Sub KeyCode_AltRight As String
	Return KeyCodes.KEYCODE_ALT_RIGHT
End Sub

Sub KeyCode_Back As String
	Return KeyCodes.KeyCode_Back
End Sub

Sub KeyCode_Call As String
	Return KeyCodes.KeyCode_Call
End Sub

Sub KeyCode_Camera As String
	Return KeyCodes.KeyCode_Camera
End Sub

Sub KeyCode_Clear As String
	Return KeyCodes.KeyCode_Clear
End Sub

Sub KeyCode_Del As String
	Return KeyCodes.KeyCode_Del
End Sub

Sub KeyCode_DPadCenter As String
	Return KeyCodes.KEYCODE_DPAD_CENTER
End Sub

Sub KeyCode_DPadDown As String
	Return KeyCodes.KEYCODE_DPAD_DOWN
End Sub

Sub KeyCode_DPadLeft As String
	Return KeyCodes.KEYCODE_DPAD_LEFT
End Sub

Sub KeyCode_DPadRight As String
	Return KeyCodes.KEYCODE_DPAD_RIGHT
End Sub

Sub KeyCode_DPadUp As String
	Return KeyCodes.KEYCODE_DPAD_UP
End Sub

Sub KeyCode_EndCall As String
	Return KeyCodes.KeyCode_EndCall
End Sub

Sub KeyCode_Enter As String
	Return KeyCodes.KeyCode_Enter
End Sub	

Sub KeyCode_Envelope As String
	Return KeyCodes.KeyCode_Envelope
End Sub

Sub KeyCode_Explorer As String
	Return KeyCodes.KeyCode_Explorer
End Sub

Sub KeyCode_Focus As String
	Return KeyCodes.KeyCode_Focus
End Sub

Sub KeyCode_Grave As String
	Return KeyCodes.KeyCode_Grave
End Sub

Sub KeyCode_HeadSetHook As String
	Return KeyCodes.KeyCode_HeadSetHook
End Sub

Sub KeyCode_Home As String
	Return KeyCodes.KeyCode_Home
End Sub

Sub KeyCode_MediaFastForward As String
	Return KeyCodes.KEYCODE_MEDIA_FAST_FORWARD
End Sub

Sub KeyCode_MediaNext As String
	Return KeyCodes.KEYCODE_MEDIA_NEXT
End Sub

Sub KeyCode_MediaPlayPause As String
	Return KeyCodes.KEYCODE_MEDIA_PLAY_PAUSE
End Sub

Sub KeyCode_MediaPrevious As String
	Return KeyCodes.KEYCODE_MEDIA_PREVIOUS
End Sub

Sub KeyCode_MediaRewind As String
	Return KeyCodes.KEYCODE_MEDIA_REWIND
End Sub

Sub KeyCode_MediaStop As String
	Return KeyCodes.KEYCODE_MEDIA_STOP
End Sub

Sub KeyCode_Menu As String
	Return KeyCodes.KeyCode_Menu
End Sub

Sub KeyCode_Mute As String
	Return KeyCodes.KeyCode_Mute
End Sub

Sub KeyCode_Notification As String
	Return KeyCodes.KeyCode_Notification
End Sub

Sub KeyCode_Num As String
	Return KeyCodes.KeyCode_Num
End Sub

Sub KeyCode_Search As String
	Return KeyCodes.KeyCode_Search
End Sub

Sub KeyCode_ShiftLeft As String
	Return KeyCodes.KEYCODE_SHIFT_LEFT
End Sub

Sub KeyCode_ShiftRight As String
	Return KeyCodes.KEYCODE_SHIFT_RIGHT
End Sub

Sub KeyCode_SoftLeft As String
	Return KeyCodes.KEYCODE_SOFT_LEFT
End Sub

Sub KeyCode_SoftRight As String
	Return KeyCodes.KEYCODE_SOFT_RIGHT
End Sub

Sub KeyCode_Sym As String
	Return KeyCodes.KeyCode_Sym
End Sub

Sub KeyCode_Tab As String
	Return KeyCodes.KeyCode_Tab
End Sub

Sub KeyCode_Unknown As String
	Return KeyCodes.KeyCode_Unknown
End Sub

Sub KeyCode_VolumeDown As String
	Return KeyCodes.KEYCODE_VOLUME_DOWN
End Sub

Sub KeyCode_VolumnUp As String
	Return KeyCodes.KEYCODE_VOLUME_UP
End Sub

''Color constants:
''Colors_Black
''Colors_Blue
''Colors_Cyan
''Colors_DarkGray
''Colors_Gray
''Colors_Green
''Colors_LightGray
''Colors_Magenta
''Colors_Red
''Colors_Transparent
''Colors_White
''Colors_Yellow
''

Sub Colors_Black As String
	Return Colors.Black
End Sub

Sub Colors_Blue As String
	Return Colors.Blue
End Sub

Sub Colors_Cyan As String
	Return Colors.Cyan
End Sub

Sub Colors_DarkGray As String
	Return Colors.DarkGray
End Sub

Sub Colors_Gray As String
	Return Colors.Gray
End Sub

Sub Colors_Green As String
	Return Colors.Green
End Sub

Sub Colors_LightGray As String
	Return Colors.LightGray
End Sub

Sub Colors_Magenta As String
	Return Colors.Magenta
End Sub

Sub Colors_Red As String
	Return Colors.Red
End Sub

Sub Colors_Transparent As String
	Return Colors.Transparent
End Sub

Sub Colors_White As String
	Return Colors.White
End Sub

Sub Colors_Yellow As String
	Return Colors.Yellow
End Sub

''Typeface constants:
''Typeface_FontDefault
''Typeface_FontMonospace
''Typeface_FontSerif
''Typeface_FontSansSerif
''Typeface_StyleNormal
''Typeface_StyleBold
''Typeface_StyleItalic
''Typeface_StyleBoldItalic
''

Sub Typeface_FontDefault As String
	Return "default"
End Sub

Sub Typeface_FontMonospace As String
	Return "monospace"
End Sub

Sub Typeface_FontSerif As String
	Return "serif"
End Sub

Sub Typeface_FontSansSerif As String
	Return "sans_serif"
End Sub

Sub Typeface_StyleNormal As String
	Return Typeface.STYLE_NORMAL
End Sub

Sub Typeface_StyleBold As String
	Return Typeface.STYLE_BOLD
End Sub

Sub Typeface_StyleItalic As String
	Return Typeface.STYLE_ITALIC
End Sub

Sub Typeface_StyleBoldItalic As String
	Return Typeface.STYLE_BOLD_ITALIC
End Sub

''These Gravity constants are for use for justifying text and images:
''Gravity_None
''Gravity_Top
''Gravity_Bottom
''Gravity_Left
''Gravity_Right
''Gravity_Center
''Gravity_CenterHorizontal
''Gravity_CenterVertical
''Gravity_Fill
''

Sub Gravity_None As String
	Return 0
End Sub

Sub Gravity_Top As String
	Return 48
End Sub

Sub Gravity_Bottom As String
	Return 80
End Sub

Sub Gravity_Left As String
	Return 3
End Sub

Sub Gravity_Right As String
	Return 5
End Sub

Sub Gravity_Center As String
	Return 17
End Sub

Sub Gravity_CenterHorizonal As String
	Return 1
End Sub

Sub Gravity_CenterVertical As String
	Return 16
End Sub

Sub Gravity_Fill As String
	Return 119
End Sub

''These functions setup and use the new default parameter system which
''improves render time of certain views by reducing the number of calls
''required for a custom view from several to just one.
''
''Sets a default set of parameters to be used with a default view
''defid		(string)	name of the parameter set
''radius	(number)	corner radius of a color drawable (see setcolor)
''color		(number)	color param of a color drawable (see setcolor)
''tcolor	(number)	text color (see settextcolor)
''tsize		(number)	text size (see settextsize)
''grav		(number)	view gravity (see setgravity)
''tface		(boolean)	true/false: indicates whether or not to set the labels typeface using the settypeface function (see settypeface)
''Example: 
''	SetTypeFace("Monospace", 1)
''	SetDefaultParams("header", 8, cgray, cwhite, 24, 21, True)
''	AddDefaultLabel("lblhname", 0, 0, 200, 40, "", "header", "Name")
''	AddDefaultLabel("lblhaddr", 210, 0, 200, 40, "", "header", "Address")
''	AddDefaultLabel("lblhphone", 420, 0, 100, 40, "", "header", "Phone")
''This example sets the typeface to bold monospace font, then sets the
''default label parameters to a corner radius of 8 (mildly rounded), a
''background color of gray, white text color, text size of 24, gravity
''(or justification) to right justifified, centered vertically, and indicates
''to use the bold monospaced typeface font. Then 3 custom labels are added,
''each with a single call.
Sub SetDefaultParams(defid As String, radius As String, color As String, tcolor As String, tsize As String, grav As String, tface As String)
	Dim d As defstdtype
	d.Initialize
	d.radius = radius
	d.color = color
	d.tcolor = tcolor
	d.tsize = tsize
	d.grav = grav
	d.tface = tface
	defmap.Put(defid, d)
End Sub

''Adds a custom label which uses the defaults as explained above. This
''allows a custom label to be rendered with a single call.
''These parameters are in addition to the standard AddLabel parameters:
''defid		(string)	name of the parameter set (see SetDefaultLabel)
''text		(string)	text of the label (see SetText)
Sub AddDefaultLabel(name As String, left As String, top As String, width As String, height As String, parent As String, defid As String, text As String)
	If defmap.ContainsKey(defid) Then
		AddLabel(name, left, top, width, height, parent)
		Dim d As defstdtype
		d = defmap.Get(defid)
		Dim v As Label
		v = viewmap.Get(name)
		If v.IsInitialized Then
			Dim C As ColorDrawable
			C.Initialize(d.color, d.radius)
			v.Background = C
			v.TextColor = d.tcolor
			v.TextSize = d.tsize
			v.Gravity = d.grav
			If d.tface Then v.Typeface = font
			If text.Length > 0 Then v.text = text
		End If
	End If
End Sub

''These functions reflect the recent changes that were made to the B4A
''Designer, which include the new Designer Script functions which are not
''available directly from code.
''
''Sets the right side of the named view
Sub SetRight(name As String, right As String)
	Dim v As View
	Dim l As Int
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.Left = right - v.Width + 1
	End If
End Sub

''Gets the right side of the named view
Sub GetRight(name As String) As String
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Left + v.Width - 1
	End If
End Sub

''Sets the bottom side of the named view
Sub SetBottom(name As String, bottom As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.Top = bottom - v.Height + 1
	End If
End Sub

''Gets the bottom side of the named view
Sub GetBottom(name As String) As String
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Top + v.Height - 1
	End If
End Sub

''Sets the horizontal center of the named view
Sub SetHCenter(name As String, hcenter As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.Left = hcenter - v.Width / 2
	End If
End Sub

''Gets the horizontal center of the named view
Sub GetHCenter(name As String) As String
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Left + v.Width / 2
	End If
End Sub

''Sets the vertical center of the named view
Sub SetVCenter(name As String, vcenter As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.top = vcenter - v.Height / 2
	End If
End Sub

''Gets the vertical center of the named view
Sub GetVCenter(name As String) As String
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		Return v.Top + v.Height / 2
	End If
End Sub

''Sets the left and right sides of the named view, adjusting its width
''as necessary
Sub SetLeftAndRight(name As String, left As String, right As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.left = left
		v.Width = right - left + 1
	End If
End Sub

''Sets the top and bottom sides of the named view, adjusting its height
''as necessary
Sub SetTopAndBottom(name As String, top As String, bottom As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.top = top
		v.Height = bottom - top + 1
	End If
End Sub

''***NOTE: The Chain and Run statements are not stable at this time.
''They seem to work properly for small scripts, but for larger scripts,
''they do not handle starting the new script properly!!!
''
'' *** USE CHAIN AND RUN AT YOUR OWN RISK !!!
''
''The Chain statement starts another B4Script program in the same project, and sends an array of args
''that the other program can catch and use via the system array Args(0). The other program also has access to
''the process safe saved data array that is accessed via GetSavedData. It is not
''necessary to use the .b4s file ext of the other program name.
''
''Usage:
''Chain("B4SProgram", "arrayname")
''
''Example: Setup.b4s:
''Dim PGlobals(4)
''...
''Dim CArgs(3)
''CArgs(0) = "My Name"
''CArgs(1) = "My Address"
''CArgs(2) = "My City, St Zip"
''SetSavedData("PGlobals")
''Chain("Address", "CArgs")
''
''Address.b4s:
''Dim PGlobals(0)
''If ArrayLen(Args) = 3 Then
''  MyName = Args(0)
''  MyAddress = Args(1)
''  MyCityStZip = Args(2)
''Endif
''Rem This program also has access to the sending programs saved global array
''GetSavedData("PGlobals")
Sub Chain(prg As String, argsarrayname As String) As String
	Dim lpath As String
	If Main.IDEMode Then
		lpath = iif(Main.ProjectPath.Length > 0, Main.ProjectPath, Main.ScriptPath)
	Else
		lpath = File.DirAssets
	End If
	If Not(prg.ToLowerCase.EndsWith(".b4s")) Then prg = prg & ".b4s"
	If Not(File.Exists(lpath, prg)) Then
		Log("Chain program not found.")
		Return False
	End If
	Dim istream As InputStream
	Dim reader As TextReader
	Dim src As String
	Try
		istream = File.OpenInput(lpath, prg)
		reader.Initialize(istream)
		src = reader.ReadAll
		src = src.Replace(Chr(Main.BOM), "") ' remove BOM if present in case file is from Windows
		src = src.Replace(Chr(13), "") ' remove CR in case file is from Windows
		ChainProgram = src
		Args = Blib.GetArray(argsarrayname)
	Catch
		Log("Error loading Chain program")
		ChainError = "Error loading Chain program"
		Return False
	End Try
	Blib.Halt
	Return True
End Sub

''Run
''
''The Run statement is similar to Chain in that it calls another B4Script program,
''but it starts fresh, as though it had just been run, instead of passing arguments
''and having access to other programs global saved arrays.
''
''Usage:
''Run("B4SProgram")
Sub Run(prg As String) As String
	Dim lpath As String
	If Main.IDEMode Then
		lpath = iif(Main.ProjectPath.Length > 0, Main.ProjectPath, Main.ScriptPath)
	Else
		lpath = File.DirAssets
	End If
	If Not(prg.ToLowerCase.EndsWith(".b4s")) Then prg = prg & ".b4s"
	If Not(File.Exists(lpath, prg)) Then
		Log("Run program not found.")
		Return False
	End If
	Dim istream As InputStream
	Dim reader As TextReader
	Dim src As String
	Try
		istream = File.OpenInput(lpath, prg)
		reader.Initialize(istream)
		src = reader.ReadAll
		src = src.Replace(Chr(Main.BOM), "") ' remove BOM if present in case file is from Windows
		src = src.Replace(Chr(13), "") ' remove CR in case file is from Windows
		RunProgram = src
		Dim Args(0) As String
		Dim SavedData(0) As String
	Catch
		Log("Error loading Run program")
		RunError = "Error loading Run program"
		Return False
	End Try
	Blib.Halt
	Return True
End Sub

''Runs the current program again
Sub Restart As String
	Restarting = True
	Blib.Halt
	Return True
End Sub

''Returns true if the named view exists, otherwise false
Sub isView(name As String) As String
	Return viewmap.ContainsKey(name)
End Sub

''Removes all views from the Activity
Sub RemoveAllViews
	Dim v As View
	Dim S As Int
	Do While viewmap.Size > 0
		S = viewmap.Size - 1
		v = viewmap.GetValueAt(S)
		v.RemoveView
		viewmap.Remove(viewmap.GetKeyAt(S))
	Loop
End Sub

''Calculates the height of the text in a label or edittext
Sub TextHeight(name As String, text As String) As String
	Dim su As StringUtils
	Dim v As View
	v = viewmap.Get(name)
	If Not(v.IsInitialized) Then Return -1
	If Not(v Is Label) Then Return -1
	Dim lbl As Label
	lbl = v
	Return su.MeasureMultilineTextHeight(lbl, text)
End Sub

''Sets the activity title text in the activity's title label
Sub SetActivityTitle(title As String)
	Activity.title = title
End Sub

''Sets the activity title text color
Sub SetActivityTitleColor(Color As String)
	Dim icolor As Int
	icolor = Color
	Activity.TitleColor = icolor
End Sub

''Removes the named view from its parent, but doesn't destroy it.
Sub RemoveFromParent(name As String)
	Dim v As View
	v = viewmap.Get(name)
	If v.IsInitialized Then
		v.RemoveView
	End If
End Sub

''Allow a custom dialog to be presented to the display.
''
''Usage:
'' InputCustom("name", "title", "positive", "cancel", "negative")
''
''Example:
''# first add your panel. It needs a black background
''AddPanel("mypanel", 0, 0, pwidth, pheight, "")
''SetColor("mypanel", 0, cBlack)
''# next, add all the desired views to the panel like this
''AddLabel("mylabel", 0, 0, 60 * ScreenScale, 30 * ScreenScale, "mypanel")
''SetText("mylabel", "label text")
''# now remove the panel from the activity
''RemoveFromParent("mypanel")
''# now call InputCustom
''sel = InputCustom("mypanel", "Yes", "Cancel", "No")
''name - the name of the view to display in the dialog, most probably a panel with other views (for a multi-view input dialog).
''title - the text in the dialog's title bar.
''positive - the text on the positive, or Ok or Yes, button. Leave blank to remove the button.
''cancel - the text on the Cancel button. Leave blank to remove the button
''negative - the text on the negative, or No, button. Leave blank to remove the button.
''Returns a dialog response
Sub InputCustom(name As String, title As String, positive As String, cancel As String, negative As String) As String
	Dim v As View
	Dim ret As Int
	v = viewmap.Get(name)
	If Not(v.IsInitialized) Then Return DialogResponse.cancel
	v.RemoveView		'just in case we forgot to in b4script code
	Dim vis As Boolean
	vis = v.Visible		'if panel hidden, unhide to show then hide again
	If Not(vis) Then v.Visible = True
	Dim cd As CustomDialog2
	cd.AddView(v, v.Width, v.Height)
	ret = cd.Show(title, positive, cancel, negative, Null)
	If Not(vis) Then v.Visible = False
	Return ret
End Sub

''Dialog reponse codes:
''DialogResponse_Positive
''DialogResponse_Cancel
''DialogResponse_Negative
''

Sub DialogResponse_Positive As String
	Return DialogResponse.POSITIVE
End Sub

Sub DialogResponse_Cancel As String
	Return DialogResponse.CANCEL
End Sub

Sub DialogResponse_Negative As String
	Return DialogResponse.NEGATIVE
End Sub

''IIf is a function that allows a traditional 5 line If statement on one line.
''It should not replace an If block that makes tests to ensure an error will not
''result. It has 3 parts: a condition, a true part and a false part. The condition
''is evaluated, and if it evaluates true, the true part is returned, otherwise
''the false part is returned.
''
''Usage:
''IIf(condition, truepart, falsepart)
''
''Example:
''instead of this...
''If a = 5 Then
''&nbsp;&nbsp;b = b + 1
''Else
''&nbsp;&nbsp;b = b - 1
''Endif
''use this...
''b = b + IIf(a = 5, 1, -1)
Sub iif(condition As String, truepart As String, falsepart As String) As String
	'condition = condition.ToLowerCase
	If condition = "true" Then
		Return truepart
	Else If condition = "false" Then
		Return falsepart
	Else
		Return ""
	End If
End Sub

''Returns a string that has had spaces trimmed from the start and end of the passed string
''Ex. StrTrim("  123 ") returns "123"
Sub StrTrim(Str As String) As String
	Return Str.Trim
End Sub

''Returns a string that containing the given number of characters from the left hand side of the passed string
''Ex. StrLeft("12345", 3) returns "123"
Sub StrLeft(str As String, ct As String) As String
	Dim C As Int
	C = ct
	Return str.SubString2(0, C)
End Sub

''The B4Script SubString statement returns what the traditional basic Mid statement returns.
''StrMid emulates the basic Mid statement with the standard Mid$ 3rd argument omitted, by returning the
''end part of the passed string, starting at the indicated index. Remember indexes into strings
''start at zero.
''Ex. StrMid("1234567", 3) returns "4567"
Sub StrMid(str As String, ct As String) As String
	Dim C As Int
	C = ct
	Return str.SubString(C)
End Sub

''Returns a string that contains the given number of characters from the right hand side of the passed string
''Ex. StrRight("123456", 2) returns "56"
Sub StrRight(str As String, ct As String) As String
	Dim C As Int
	C = ct
	Return str.SubString(str.Length - C)
End Sub

''The isNumeric function is safer to use than the B4Script isNumber statement, in that it will not generate
''an error if the passed number is blank instead of containing digits, or returning false for fractions
''starting with the decimal point instead of an actial numeric digit.
''Care MUST be taken, because although isNumeric will return True for a number starting with a decimal point, as in .5,
''B4Script cannot use that number without a leading 0 (ie. 0.5) and will cause an error if its omitted.
''
''Example 1:
''isNumber("") - generates an error
''isNumeric("") - returns false
''Example 2:
''isNumber(".5") - returns false
''isNumeric(".5") - returns true
Sub isNumeric(num As String) As String
	If num.Length = 0 Then
	  Return False
	Else If num = "." Then
	  Return False
	Else If num.StartsWith(".") Then
		Return IsNumber(num.SubString(1))
	Else
		Return IsNumber(num)
	End If
End Sub

#End Region

#Region Other Events

Sub tmrChain_Tick
	Dim ok As Boolean
	tmrChain.Enabled = False
	If ChainProgram.Length > 0 Then
		Program = ChainProgram
		ChainProgram = ""
	Else If RunProgram.Length > 0 Then
		Program = RunProgram
		RunProgram = ""
		Dim Args(0) As String	'resetting args() and saveddata() is what differentiates run from chain
		Dim SavedData(0) As String
	Else If Restarting Then
		Restarting = False
		Dim SavedData(0) As String
	End If
	ok = Blib.LoadCodeAsString(Include(Program))
	If ok Then
		RemoveAllViews
'		Dim Obj1 As Reflector
'		Obj1.Target = Obj1.GetActivity
'		' clear the menu items, the original menu itself still exists
'		Obj1.SetField2("menuItems", Null) 
'		    
'		' add the required menu items
'		Activity.AddMenuItem("three", "")
'		Activity.AddMenuItem("four", "")
'		Activity.AddMenuItem("five", "")
'		    
'		' rebuild the menu
'		Obj1.RunMethod("invalidateOptionsMenu")
		FirstRunFlag = True
		ForceActivityResume = True
		Blib.Run(Args)
	Else
		Blib_Ended(Blib.ErrorString)
	End If	
End Sub

''<a href="#top">Contents</a>
''<a name="other"></a>

''OTHER EVENT FUNCTIONS
''
''These additional Events have been added by B4A user JesseW to compliment the BasicLib library and extend its functionality.
''

''Event Label_Click can now be used in your B4Script.
''No errors will be triggered if omitted.
''Usage:
''Sub Label_Click(who)
''	-- your label click event code goes here
''	-- who has the name of the label, as a string, that caused the Click event.
''End Sub
''
'Call the script "Sub label_click(sender)" when any Label Click event is raised. 
Sub Label_Click
	If Blib.CanCall("label_click") Then
		Dim v As View
		v = Sender	
		Dim params(1) As String
		params(0) = v.Tag
		Blib.Call("label_click", params)
	End If
End Sub

''Event Panel_Click can now be used in your B4Script.
''No errors will be triggered if omitted.
''Usage:
''Sub Panel_Click(who)
''	-- your panel click event code goes here
''	-- who has the name of the panel, as a string, that caused the Click event.
''End Sub
''
'Call the script "Sub panel_click(sender)" when any Panel_Click event is raised. 
Sub Panel_Click
	If Blib.CanCall("panel_click") Then
		Dim v As View
		v = Sender	
		Dim params(1) As String
		params(0) = v.Tag
		Blib.Call("panel_click", params)
	End If
End Sub

''Event Edit_FocusChanged can now be used in your B4Script.
''No errors will be triggered if omitted.
''Usage:
''Sub Edit_FocusChanged(who, hasfocus)
''	-- your edittext focus changed event code goes here
''	-- who has the name of the edittext, as a string, that caused the FocusChanged event.
''	-- hasfocus is true if the edittext gained focus, false if it lost focus.
''End Sub
''
Sub EditText_FocusChanged(HasFocus As Boolean)
	Log("EditText_FocusChanged(" & HasFocus & ")")
	If Blib.CanCall("edit_focuschanged") Then
		Log("Blib.CanCall(" & QUOTE & "edit_focuschanged" & QUOTE & ")")
		Dim v As View
		v = Sender
		Dim params(2) As String
		params(0) = v.Tag
		params(1) = HasFocus
		Blib.Call("edit_focuschanged", params)
	End If
End Sub

''<a href="#top">Contents</a>

#End Region
